// Copyright 2008 Dolphin Emulator Project
// Licensed under GPLv2+
// Refer to the license.txt file included.


// This header contains type definitions that are shared between the Dolphin core and
// other parts of the code. Any definitions that are only used by the core should be
// placed in "Common.h" instead.

#pragma once

#include <cstdint>

#ifdef _WIN32
#include <tchar.h>
#else
// For using Windows lock code
#define TCHAR char
#define LONG int
#endif

typedef uint8_t  u8;
typedef uint16_t u16;
typedef uint32_t u32;
typedef uint64_t u64;

typedef int8_t  s8;
typedef int16_t s16;
typedef int32_t s32;
typedef int64_t s64;


typedef	intptr_t sPointer;
typedef uintptr_t uPointer;

typedef float  f32;
typedef double f64;

union Word
{
    f32 float32;
    u32 bits32;
    u16 bits16[2];
    u8  bits8[4];
};

union DWord
{
    u64 bits64;
    f64 float64;
    f32 float32[2];
    u32 bits32[2];
    u16 bits16[4];
    u8  bits8[8];

    Word word[2];
};

union QWord
{
    u64 bits64[2];
    f64 float64[2];
    f32 float32[4];
    u32 bits32[4];
    u16 bits16[8];
    u8  bits8[16];

    Word word[4];
    DWord dword[2];
};