#pragma once

#define MAX_TEXTURE_X 512
#define MAX_TEXTURE_Y 512

typedef struct OGLVertexTag
{
    GLfloat x;
    GLfloat y;
    GLfloat z;

    GLfloat sow;
    GLfloat tow;

    union COLTAG
    {
        unsigned char col[4];
        unsigned int lcol;
    } c;
} OGLVertex;

class GPUPatches
{
public:
    typedef BOOL(__cdecl* tOffset)(void);

    GPUPatches();
    ~GPUPatches();

    struct GTEData
    {
        s16* lx0;
        s16* lx1;
        s16* lx2;
        s16* lx3;

        s16* ly0;
        s16* ly1;
        s16* ly2;
        s16* ly3;

        OGLVertex* vertex[4];

        s16* PSXDisplay_CumulOffset_x;
        s16* PSXDisplay_CumulOffset_y;
    };

    void GTEAccuracy();
    void FixMemoryDetection();
	void EnableVsync(u32 interval);
    void ResHack(u32 _x, u32 _y);
	void HardcoreMode(HWND hWnd);
	void TextureScale(u8 scale);

private:
    static GTEData m_gtedata;
	static u8 m_scale;

    static BOOL __cdecl offset3(void);
    static BOOL __cdecl offset4(void);
    static void fix_offsets(u32 _case = 4);
    static tOffset ooffset3;
    static tOffset ooffset4;

    int GetVideoMemoryAMD();
    int GetVideoMemoryNV();

	static WNDPROC oldWndProc;
	static LRESULT CALLBACK TweakWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	static void(APIENTRY* oglTexSubImage2D)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
	static void APIENTRY Hook_glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);

	static void(APIENTRY* oglTexImage2D)(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void *pixels);
	static void APIENTRY Hook_glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const void *pixels);

	static void(APIENTRY* oglCopyTexSubImage2D)(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	static void APIENTRY Hook_glCopyTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);

	static u8* m_RGBABuf;
};