// gpuPeteOGL2Fixes.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"

#include "gpuPeteOpenGL2Tweak.h"
#include "GPUPlugin.h"

//#define EXPORT_LOG(format, ...) PLUGINLOG(format, __VA_ARGS__)
#define EXPORT_LOG(format, ...) 

const char* CALLBACK PSEgetLibName(void)
{
    EXPORT_LOG(__FUNCTION__);
	return libraryName;
}

u32 CALLBACK PSEgetLibType(void)
{
    EXPORT_LOG(__FUNCTION__);
	return  2;
}

u32 CALLBACK PSEgetLibVersion(void)
{
    EXPORT_LOG(__FUNCTION__);
    return 1 << 16 | VERSION_MAJOR << 8 | VERSION_MINOR;
}

s32 CALLBACK GPUinit()
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUinit();
}

s32 CALLBACK GPUshutdown()
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUshutdown();
}

s32 CALLBACK GPUopen(HWND hwndGPU)
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUOpen(hwndGPU);;
}

s32 CALLBACK GPUclose()
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUclose();
}

s32 CALLBACK GPUconfigure()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUconfigure();
}

void CALLBACK GPUabout()
{
    EXPORT_LOG(__FUNCTION__);
    return GPUPlugin::Get().GPUabout();
}

s32 CALLBACK GPUtest()
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUtest();
}

u32 CALLBACK GPUreadStatus()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUreadStatus();
}

u32 CALLBACK GPUreadData()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUreadData();
}

void CALLBACK GPUreadDataMem(u32* pMem, s32 iSize)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUreadDataMem(pMem, iSize);
}

void CALLBACK GPUwriteStatus(u32 gdata)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUwriteStatus(gdata);
}

void CALLBACK GPUwriteData(u32 gdata)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUwriteData(gdata);
}

void CALLBACK GPUwriteDataMem(u32* pMem, s32 iSize)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUwriteDataMem(pMem, iSize);
}

s32 CALLBACK GPUgetMode()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUgetMode();
}

void CALLBACK GPUsetMode(u32 gdata)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUsetMode(gdata);
}

void CALLBACK GPUupdateLace()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUupdateLace();
}

s32 CALLBACK GPUdmaChain(u32 * baseAddrL, u32 addr)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUdmaChain(baseAddrL, addr);
}

void CALLBACK GPUmakeSnapshot()
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUmakeSnapshot();
}

void CALLBACK GPUkeypressed(u32 key)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUkeypressed(key);
}

void CALLBACK GPUdisplayText(s8 * text)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUdisplayText(text);
}

void CALLBACK GPUdisplayFlags(u32 dwFlags)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUdisplayFlags(dwFlags);
}

s32 CALLBACK GPUfreeze(u32 ulGetFreezeData, struct GPUFreeze_t* pF)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUfreeze(ulGetFreezeData, pF);
}

s32 CALLBACK GPUgetScreenPic(u8 * pMem)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUgetScreenPic(pMem);
}

s32 CALLBACK GPUshowScreenPic(u8 * pMem)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUshowScreenPic(pMem);
}

void CALLBACK GPUclearDynarec(void(CALLBACK *callback)(void))
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUclearDynarec(callback);
}

void CALLBACK GPUhSync(s32 val)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUhSync(val);
}

void CALLBACK GPUvBlank(s32 val)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUvBlank(val);
}

void CALLBACK GPUvisualVibration(u32 iSmall, u32 iBig)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUvisualVibration(iSmall, iBig);
}

void CALLBACK GPUcursor(s32 iPlayer, s32 x, s32 y)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUcursor(iPlayer, x, y);
}

void CALLBACK GPUaddVertex(s16 sx, s16 sy, s64 fx, s64 fy, s64 fz)
{
    EXPORT_LOG(__FUNCTION__);
    return context.OnGPUaddVertex(sx, sy, fx, fy, fz);
}

void CALLBACK GPUsetfix(u32 dwFixBits)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUsetfix(dwFixBits);
}

void CALLBACK GPUsetframelimit(u32 option)
{
    EXPORT_LOG(__FUNCTION__);
	return GPUPlugin::Get().GPUsetframelimit(option);
}
